"use strict";
cc._RF.push(module, 'c66d7hNDK1HJ5Y8Dc2614dp', 'cui');
// Script/cui.js

'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function Cui(node) {
    if (node == undefined) {
        Cui.currentNode = undefined;
        return;
    }
    if (typeof node == 'string') {
        if (Cui.node[node]) Cui.currentNode = Cui.node[node];else Cui.currentNode = new cc.Node();
    } else {
        Cui.currentNode = node;
    }
    return Cui.currentNode;
};
Cui.init = function () {
    this.currentNode = {};
    this.node = {};
};

window.cui = Cui;
Cui.currentNode = {};
Cui.node = {};
Cui.exbindObj = {};

cc.Node.prototype.isBind = function (symbol) {
    if (this.name.split(symbol).length > 1) return this.name.split(symbol)[1];
    return false;
};
Cui.isBind = function (node, symbol) {
    return node.isBind(symbol);
};

cc.Node.prototype.forBind = function () {
    var i, j;
    for (i = 0; i < this.childrenCount; i++) {
        if (this.children[i].isBind('#')) {
            cui.node[this.children[i].isBind('#')] = this.children[i];
        }
        for (j in cui.exbindObj) {
            if (this.children[i].isBind(cui.exbindObj[j].config.symbol)) cui.exbindObj[j].node[this.children[i].isBind(cui.exbindObj[j].config.symbol)] = this.children[i];
        }
        if (this.children[i].childrenCount > 0) this.children[i].forBind();
    }
};
Cui.forBind = function (node) {
    node.forBind();
};

cc.Node.prototype.findChild = function (symbol, name) {
    for (var i = 0; i < this.childrenCount; i++) {
        if (this.children[i].isBind(symbol) && name == this.children[i].isBind(symbol)) return this.children[i];
    }
};
Cui.findChild = function (symbol, name) {
    if (!this.currentNode) return {};
    return this.currentNode.findChild(symbol, name);
};

cc.Node.prototype.cbind = function (isChildren) {
    if (isChildren) {
        this.forBind();
    } else {
        if (this.isBind('#')) cui.node[this.isBind('#')] = this;
    }
};
Cui.bind = function (node, isChildren) {
    if (node) {
        if (isChildren) {
            this.forBind(node);
        } else if (this.isBind(node)) this.node[this.isBind(node)] = node;
    } else {
        this.init();
        this.forBind(cc.find('Canvas'));
    }
};

cc.Node.prototype.copyNode = function () {
    return cc.instantiate(this);
};

cc.Node.prototype.size = function (p0, p1) {
    if ((typeof p0 === 'undefined' ? 'undefined' : _typeof(p0)) == 'object') {
        this.width = p0.x, this.height = p0.y;
    } else {
        this.width = p0, this.height = p1;
    }
};

cc.Node.prototype.forChildren = function (callback) {
    for (var i = 0; i < this.childrenCount; i++) {
        if (callback(this.children[i], i) == false) break;
    }
};

cc.Node.prototype.getChildByPath = function (path) {
    path = path.split('/');
    var i,
        node = this;
    for (i = 0; i < path.length; i++) {
        node = node.getChildByName(path[i]);
    }return node;
};
Cui.getChildByPath = function (path) {
    if (!this.currentNode) return undefined;
    return this.currentNode.getChildByPath(path);
};

cc.Node.prototype.getAttr = function (key) {
    return this['cui' + key];
};
Cui.getAttr = function (key) {
    if (!this.currentNode) return undefined;
    return this.currentNode.getAttr['cui' + key];
};

Cui.timeoutCall = function (callback) {
    setTimeout(function () {
        callback();
    }, 60);
};

cc.Node.prototype.setAttr = function (key, value) {
    if (value == false) delete this['cui' + key];else this['cui' + key] = value;
    return this['cui' + key];
};
Cui.setAttr = function (key, value) {
    if (!this.currentNode) return {};
    return this.currentNode.setAttr(key, value);
};

cc.Node.prototype.getCname = function () {
    return this.name.split('#')[1];
};
Cui.getCname = function () {
    //获取cui name
    if (!this.currentNode) return undefined;
    return this.currentNode.getCname();
};

Cui.bindData = function (data) {
    var i;

    var _loop = function _loop() {
        var node = data[i];
        if (node.value != undefined) {
            if (node.view.length != undefined) {
                var _i = 0;
                for (; _i < node.view.length; _i++) {
                    node.view[_i][node.key] = node.value;
                }
            } else {
                node.view[node.key] = node.value;
            }
        }
        Object.defineProperty(node, 'value', {
            get: function get() {
                return node.value;
            },
            set: function set(value) {
                if (node.view.length != undefined) {
                    var _i2 = 0;
                    for (; _i2 < node.view.length; _i2++) {
                        node.view[_i2][node.key] = value;
                    }
                } else {
                    node.view[node.key] = value;
                }
                node.callback && node.callback(value);
            }
        });
    };

    for (i in data) {
        _loop();
    }
};

Cui.newIdNum = 0;
Cui.newId = function () {
    this.newIdNum++;
    if (this.newIdNum > 1000) this.newIdNum = 0;
    return new Date().getTime() + this.newIdNum;
};

cc.Node.prototype.toggle = function () {
    this.active = !this.active;
    return this.active;
};
Cui.toggle = function () {
    if (!this.currentNode) return {};
    return this.toggle();
};

cc.Node.prototype.show = function () {
    this.active = true;
};
Cui.show = function () {
    if (!this.currentNode) return {};
    this.show();
};

cc.Node.prototype.hide = function () {
    this.active = false;
};
Cui.hide = function () {
    if (!this.currentNode) return {};
    this.hide();
};

cc.Node.prototype.loadImg = function (url, callback) {
    var thisobj = this;
    cc.loader.load(cui.ajax.url + url, function (err, texture) {
        if (texture) thisobj.$v('Sprite').spriteFrame = new cc.SpriteFrame(texture);
        callback && callback();
    });
};
Cui.load = {};
Cui.load.img = function (url, node, callback) {
    cc.loader.load(url, function (err, texture) {
        if (texture) node.$v('Sprite').spriteFrame = new cc.SpriteFrame(texture);
        callback && callback();
    });
};

cc.Node.prototype.$f = function (name) {
    return this.getChildByName(name);
};
cc.Node.prototype.$fs = function (name) {
    var i = 0;
    for (; i < this.childrenCount; i++) {
        if (this.children[i].name == name) return this.children[i];
        if (this.children[i].childrenCount > 0) {
            if (this.children[i].$fs(name)) return this.children[i].$fs(name);
        }
    }
};

cc.Node.prototype.$d = function () {
    this.destroy();
};
cc.Node.prototype.$ds = function () {
    for (var i = 0; i < this.childrenCount; i++) {
        if (cc.isValid(this.children[i])) this.children[i].destroy();
    }
};

cc.Node.prototype.$v = function (type) {
    return this.getComponent(eval('cc.' + type)) || {};
};
Cui.$v = function (type) {
    if (!this.currentNode) return {};
    return this.currentNode.$v(type);
};

cc.Node.prototype.$e = function (type, callback, bindObj) {
    if (type == 'tend') type = cc.Node.EventType.TOUCH_END;else if (type == 'tstart') type = cc.Node.EventType.TOUCH_START;else if (type == 'tmove') type = cc.Node.EventType.TOUCH_MOVE;
    this.on(type, callback, bindObj);
};
Cui.$e = function (type, callback, bindObj) {
    if (!this.currentNode) return {};
    this.currentNode.$e(type, callback, bindObj);
};

Cui.extends = function (name, data) {
    if (!this[name]) this[name] = {};
    for (var i in data) {
        this[name][i] = data[i];
    }
    this[name].node = {};
    if (data.config) {
        this.exbindObj[name] = this[name];
    }
    if (data.onload) data.onload();
};

if (!window.cuiConfig) window.cuiConfig = {};

cc._RF.pop();