"use strict";
cc._RF.push(module, 'e4bf5sZ6D9CMKAFtUSr1Gt0', 'webSocket');
// Script/webSocket.js

'use strict';

window.ws = {};

// ws://47.93.174.194:8282   服务器
// ws://192.168.2.113:8282

var ws = {
    currentObj: undefined,
    serverUrl: '192.168.2.116', //192.168.2.116
    wsUrl: 'ws://119.29.85.62:9191',
    heartbeat: undefined,
    heartbeatTime: 6000,
    closeLock: false,
    eventList: {},
    eventListLength: 0, //eventList递增，0 - 1000
    lockEvent: {}, //事件锁
    cacheData: {}, //数据缓存
    complete: function complete() {},
    onClose: function onClose() {}, //当与服务器断开时触发
    reconnectionState: 0, //是否重连过，2 重连过，其余不是
    readyState: 0, // 0 未连接, 1 连接成功, 2 重连中, 3 断开连接, 4 错误
    init: function init(reconnection) {
        //初始化
        if (this.currentObj) this.currentObj.close();
        //if (!reconnection) ccPlus.ui.loading.show('正在连接服务器...');

        setTimeout(function () {
            ws.closeLock = false;
            ws.currentObj = new WebSocket(ws.wsUrl);
            ws.currentObj.onopen = ws.open;
            ws.currentObj.onclose = ws.close;
            ws.currentObj.onerror = ws.error;
            ws.currentObj.onmessage = ws.message;
        }, 1500);
    },
    open: function open() {
        //连接成功
        ws.readyState = 1;
        if (ws.reconnectionState == 0) ws.reconnectionState = 1;
        //   ccPlus.ui.loading.hide();
        cui('login1').$v('Label').string = '连接成功';
        ws.complete();
        ws.heartbeat = setInterval(function () {
            ws.heartbeatSend();
        }, ws.heartbeatTime);
    },
    close: function close(type) {
        //断开连接
        if (ws.closeLock) return; //兼容不同浏览器的close
        ws.readyState = 3;
        ws.closeLock = true;
        ws.onClose();
        //  ccPlus.ui.loading.show('网络已断开, 即将尝试重连');
        setTimeout(function () {
            ws.reconnection();
        }, 3000);
    },
    error: function error() {
        //错误
        ws.error = 4;
    },
    heartbeatSend: function heartbeatSend() {//心跳
        //cc.log('发送心跳');
        // ws.send({
        // url: 'Login/ping'
        // data: {
        //     time: new Date().getTime()
        // }
        // });
    },
    heartbeatStop: function heartbeatStop() {
        clearInterval(ws.heartbeat);
    },
    reconnection: function reconnection() {
        //重连
        if (ws.reconnectionState == 1) ws.reconnectionState = 2;
        ws.heartbeatStop();
        ws.currentObj.close();
        ws.readyState = 2;
        //ccPlus.ui.loading.show('正在尝试重连...');
        ws.init(true);
    },
    send: function send(data, timeOut) {
        //发送数据
        if (typeof data != 'string') data = JSON.stringify(data);
        timeOut = timeOut || 0;
        setTimeout(function () {
            ws.currentObj.send(data);
        }, timeOut);
    },
    newBackId: function newBackId() {
        //生成backId
        this.eventListLength += 1;
        this.eventListLength > 1000 && (this.eventListLength = 0);
        return 'backId' + new Date().getTime().toString() + this.eventListLength.toString();
    },
    sendEvent: function sendEvent(data, callBack, timeOut) {
        var backId = this.newBackId();
        this.eventList[backId] = callBack;
        if (!data.data) data.data = {};
        data.data.backId = data.data.backId || backId;
        timeOut = timeOut || 0;
        setTimeout(function () {
            ws.send(data);
        }, timeOut);
    },
    message: function message(event) {
        //接受服务器数据
        if (!event.data) return;
        var data;
        if (typeof event.data == 'string') {
            try {
                data = JSON.parse(event.data);
            } catch (e) {
                return;
            }
        }

        cui.prefab.bind('list', [data], function (node, d) {
            node.$f('content').$v('Label').string = d.data.count;
            if (content.getChildrenCount() > 0) {
                var num = parseInt(content.children[content.getChildrenCount() - 1].$f('content').$v('Label').string);
                if (d.data.count - num > 1) {
                    cui.prefab.bind('list1', [d], function (node1, d) {
                        node1.$f('content').$v('Label').string = d.data.count;
                    }, content);
                }
            }
        }, content);

        if (data.errCode != undefined) {
            ws.eventList['serverErr'](data);
            return;
        }
        if (data.backId && ws.eventList[data.backId] && !ws.lockEvent[data.backId]) {
            if (!data.data) data.data = {};
            ws.eventList[data.backId](data);
            if (data.backId.substr(0, 6) == 'backId') delete ws.eventList[data.backId];
        }
    }
};
ws.eventList['serverErr'] = function () {}; //服务器的错误，异常
window.ws = ws;

cc._RF.pop();